<?xml version="1.0" encoding="UTF-8" ?>

<!-- ====================================================================== -->
<!-- copyright 2000 by voxeo corporation. (see LGPL.txt) 					-->
<!-- ====================================================================== -->
<!--																		-->
<!-- v1.0 Coded in ColdFusion												-->
<!-- v1.0 Coded by Shane Smith and Stephen J. Lewis							-->
<!--																		-->
<!-- This application is a very simple "Telephone Simon" that generates		-->
<!-- random sequences of numbers for the caller to input.  Like normal		-->
<!-- simon games, it starts with a one digit sequence, and then increases	-->
<!-- indefinitely until the caller makes a mistake.    						-->
<!--																		-->
<!-- This zip file contains the following files:				 			-->
<!--     Simon.xml             <---- The main menu of application			-->
<!--     Play.cfm              <---- This file							  	-->
<!--     Check.cfm             <---- Small file that checks the caller's	-->
<!--                                 response with Simon					-->
<!--     Finished.xml          <---- Ending file (when the caller has lost) -->
<!--     LGPL.txt              <---- opensource license agreement			-->
<!--     Readme.txt            <---- Introduction to this application		-->			
<!--																		-->
<!-- Several audio files are associated with this application:				-->
<!--           MainMenu.wav													-->
<!--           ThankYou.wav													-->
<!--           OhNo.wav														-->	
<!--           YouAcquired.wav												-->
<!--           Points.wav													-->
<!--           YouHaveTakenTooLong.wav									    -->
<!--                                                                        -->
<!-- All audio files are PCM format, 8-bit, mono, unsigned.                 -->
<!--                                                                        -->
<!-- ====================================================================== -->

<callxml>

<block>

<cfoutput>
  <!-- ============================================================== -->
  <!-- We need to do a special check here as ColdFusion seems to have -->
  <!-- difficulty if a variable is not on the querystring -- that is, -->
  <!-- it doesn't default to "" or null, etc.  But TotalDigits starts -->
  <!-- at 0 if this is our first time in, so we can check for that.	  -->
  <!--																  -->
  <!-- Basically, we simply append a new random digit onto the end	  -->
  <!-- for each pass through this file.								  -->
  <!-- ============================================================== -->

  <cfif TotalDigits is "0">
    <assign var="CurrentNumber" value="#randrange(1,9)#" />
  <cfelse>
    <cfset NewCurrentNumber=CurrentNumber & randrange(1,9)/>
    <assign var="CurrentNumber" value="#NewCurrentNumber#" />    
  </cfif>
  
  <!-- =================================================== -->
  <!-- Increase the total number of digits in the sequence -->
  <!-- =================================================== -->

  <cfset NewTotalDigits=IncrementValue(#TotalDigits#)/>
  <assign var="TotalDigits" value="#NewTotalDigits#"/>

  <!-- ======================================================= -->
  <!-- Play the current number sequence for the caller to hear -->
  <!-- ======================================================= -->
    
  <playnumber value="$CurrentNumber;" 
              format="digits" />
			  
  <!-- ======================================================== -->
  <!-- Get the caller's guess at the digit sequence.  When they -->
  <!-- have reached the proper length, go to the "verify" page  -->
  <!-- to check their answer.  If they take too much time, then -->
  <!-- they have forfeited the game.                            -->
  <!-- ======================================================== -->

  <block>
    <getdigits var="CallersGuess" 
			   maxdigits="$TotalDigits;"
	  		   cleardigits="TRUE" 
			   maxsilence="5s"
			   maxtime="30s"/>

	  <onmaxdigits> 
		<goto value="check.cfm" submit="*" method="get"/> 
	  </onmaxdigits> 

	  <onmaxtime> 
	    <goto value="finished.xml" submit="*" method="get" /> 
	  </onmaxtime> 
 
	  <onmaxsilence> 
	    <goto value="finished.xml" submit="*" method="get" /> 
	  </onmaxsilence> 
  </block>
</cfoutput>

</block>
</callxml>
