// ----------------------------------------------------------------------
// copyright 2000 by voxeo corporation. (see LGPL.txt) 					
// ---------------------------------------------------------------------- 
//																		
// v1.0 Coded in PHP												
// v1.0 Coded by Stephen J. Lewis							
// 																		
// v1.0 converted to Java by Omi Chandiramani
// ---------------------------------------------------------------------- 
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse; 

import java.io.IOException;
import java.io.PrintWriter;

import java.util.Random;

public class Simon extends HttpServlet {

  PrintWriter out;
  
  public void doGet (HttpServletRequest request,
                     HttpServletResponse response)
    throws ServletException, IOException
  {

  
    /* set content type */
    response.setContentType("text/html");	
    /* prepare the response output stream for writing  */
    out = response.getWriter();

    /*
     * Initialize the callXML
     */
	
    out.println ("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
    out.println ("<callxml>");
	

    /*
     * Figure out which point in the game we are in 
     */

    String mode = getStringParameter (request, "mode");

    if (mode.equals("playing"))
      playing (out, request);
    else if (mode.equals("checking" ))
      checking (out, request);
    else if (mode.equals ("endgame"))
      endGame(out, request);
    else 
      mainMenu (out);

    /*
     * Close the callXML
     */
	
    out.println ("</callxml>");
	
    /* finally close the servlets output stream */
    out.close();
	
  }

  /* 
   * The starting point of the game. 
   * This will play a welcome greeting and 
   * explain the rules.               
   */ 
   
  private void mainMenu(PrintWriter out) {

    out.println ("<block label=\"Main\">");
  
    /*  
     * Here we set three variables.                                 
     * CurrentNumber is the sequence of numbers Simon asks for.     
     * TotalDigits is simply the length of that string of numbers.  
     * Score is basically 50 points times the TotalDigits variable. 
     */  

    out.println ("<assign var=\"currentnumber\" value=\"\"  />");
    out.println ("<assign var=\"totaldigits\"   value=\"0\" />");
    out.println ("<assign var=\"score\"         value=\"0\" />"); 
    
    out.println ("<menu label=\"MainMenu\" " + 
                 "repeat=\"3\" " + 
                 "format=\"audio/wav\" " +
                 "value=\"MainMenu.wav\" " +		  
                 "cleardigits=\"TRUE\" " + 
                 "termdigits=\"#\" " + 
                 "maxtime=\"60s\" " +
                 "maxsilence=\"20s\" >");
	       
    /*
     * By hitting the # key, the caller is ready to start. 
     */ 

    out.println ("<ontermdigit value=\"#\">"); 
    out.println ("  <goto value=\"Simon?mode=playing\" submit=\"*\" method=\"get\" />"); 
    out.println ("</ontermdigit>");
	  
    /*
     * If the user takes too much time, then 
     * inform them as such and hangup.       
     */

    out.println ("<onmaxtime>");
    out.println ("  <goto value=\"YouHaveTakenTooLong.wav\" submit=\"*\" method=\"get\" />"); 
    out.println ("</onmaxtime>"); 
	  
    out.println ("<onmaxsilence>");
    out.println ("  <goto value=\"YouHaveTakenTooLong.wav\" submit=\"*\" method=\"get\" />"); 
    out.println ("</onmaxsilence>");
    out.println ("</menu>");

    out.println ("</block>");


  }

  /* 
   * Figures out the next random number in the
   * sequence and asks the user to punch in the 
   * new number. 
   */
  private void playing(PrintWriter out, HttpServletRequest request) {

    /*
     * Get a random number from 0 - 9
     */
  
    int RandomNumber = Math.abs (new Random().nextInt() % 10);

    /*  												  
     * We simply append a new random digit onto the end	  
     * for each pass through this file.								  
     */ 

    String NewCurrentNumber = getStringParameter(request, "currentnumber") + RandomNumber;
    out.println ("<assign var=\"currentnumber\" value=\"" + NewCurrentNumber + "\" />");    
    
    /*
     * Increase the total number of digits in the sequence 
     */ 

    int NewTotalDigits = getIntParameter (request, "totaldigits") + 1; 
    out.println ("<assign var=\"totaldigits\" value=\"" + NewTotalDigits + "\"/>");

    /*
     * Play the current number sequence for the caller to hear 
     */
	
    out.println ("<playnumber value=\"" + NewCurrentNumber + "\" format=\"digits\" />");
			  
    /*  
     * Get the caller's guess at the digit sequence.  When they 
     * have reached the proper length, go to the "verify" code  
     * to check their answer.  If they take too much time, then 
     * they have forfeited the game.                            
     */  

    out.println ("<block>");
    out.println ("<getdigits var=\"callersguess\" " +
                 "maxdigits=\"" + NewTotalDigits + "\" " +
                 "cleardigits=\"TRUE\" " + 
                 "maxsilence=\"5s\" " +
                 "maxtime=\"30s\"/>");

    out.println ("<onmaxdigits>"); 
    out.println ("  <goto value=\"Simon?mode=checking\" submit=\"*\" method=\"get\"/>");
    out.println ("</onmaxdigits>"); 

    out.println ("<onmaxtime>"); 
    out.println ("  <goto value=\"Simon?mode=endgame\" submit=\"*\" method=\"get\" />");
    out.println ("</onmaxtime>");
 
    out.println ("<onmaxsilence>");
    out.println ("  <goto value=\"Simon?mode=endgame\" submit=\"*\" method=\"get\" />");
    out.println ("</onmaxsilence>"); 
    out.println ("</block>");  


  }

  /*
  * If the caller's guess matches the current sequence  
  * of numbers, then play a little "ding" noise and     
  * increase the length of the sequence.  Otherwise,    
  * the user has lost and we go to our endgame routine. 
  */ 
  
  private void checking (PrintWriter out, HttpServletRequest request) {

    out.println ("<block> ");
  
    if (getStringParameter(request, "currentnumber").equals (getStringParameter(request, "callersguess"))) { 
      out.println ("<playaudio value=\"Ding.wav\" />");
	    
      int NewScore = getIntParameter(request, "score") + 50;
	    
      out.println ("<assign var=\"score\" value=\"" + NewScore + "\" />");
	    
      out.println ("<goto value=\"Simon?mode=playing\" method=\"get\" submit=\"*\" />");	  

    } else {
      out.println ("<goto value=\"Simon?mode=endgame\" submit=\"*\" method=\"get\" />");
    }  

    out.println ("</block>");

  }

    /*  
     * Since the caller entered an incorrect answer, play 
     * a little "oh no!" sound, then tell them how many   
     * points they scored.                                
     */
	
  private void endGame(PrintWriter out, HttpServletRequest request) { 

    out.println ("<block> ");
	
    out.println ("<playaudio value=\"OhNo.wav\" />");
    out.println ("<playaudio value=\"YouAcquired.wav\" />");  
    out.println ("<playnumber value=\"" + getStringParameter(request, "score") + "\" format=\"number\" />"); 
    out.println ("<playaudio value=\"Points.wav\" />");  
	
    /* 
     * Final menu.  Give them a chance to play 
     * again by pressing the pound key.        
     */ 
	
    out.println ("<menu repeat=\"2\" " +
                 "value=\"ThankYou.wav\" " +
                 "termdigits=\"#\" " + 
                 "cleardigits=\"TRUE\" " +
                 "maxsilence=\"5s\" " +
                 "maxtime=\"30s\">");
	
    out.println ("<ontermdigit value=\"#\">");
    out.println ("  <goto value=\"Simon\" method=\"get\" submit=\"*\" />");
    out.println ("</ontermdigit>");
    out.println ("</menu>");
    out.println ("</block>");
	
  }


  /* 
   * Helper function to get integer parameter 
   * values that are passed to the servlet. 
   * Returns 0 if integer parameter wasn't 
   * found
   */
  private int getIntParameter (HttpServletRequest request, String key) { 
    return request.getParameter (key) == null ? 0 : Integer.parseInt(request.getParameter(key)); 
  }
    
  /* 
   * Helper function to get string parameter 
   * values that are passed to the servlet. 
   * Returns "" if integer parameter wasn't 
   * found
   */
  private String getStringParameter (HttpServletRequest request, String key) { 
    return request.getParameter (key) == null ? "" : request.getParameter(key); 
  }
    
}

