<%@ LANGUAGE = VBScript %>
  
<%

' ----------------------------------------------------------------------
' copyright 2000 by voxeo corporation. (see LGPL.txt) 					
' ---------------------------------------------------------------------- 
'																		
' v1.0 Coded in ASP											
' v1.0 Coded by Stephen J. Lewis							
'																		
' This application is a very simple "Telephone Simon" that generates		
' random sequences of numbers for the caller to input.  Like normal		
' simon games, it starts with a one digit sequence, and then increases	
' indefinitely until the caller makes a mistake.    						
'																		
' This zip file contains the following files:				 			
'     simon.asp             <---- This file								
'     LGPL.txt              <---- opensource license agreement			
'     Readme.txt            <---- Introduction to this application					
'																		
' Several audio files are associated with this application:				
'           MainMenu.wav													
'           ThankYou.wav													
'           OhNo.wav															
'           YouAcquired.wav												
'           Points.wav													
'           YouHaveTakenTooLong.wav									    
'                                                                        
' All audio files are PCM format, 8-bit, mono, unsigned.                 
'                                                                        
' ---------------------------------------------------------------------- 

'-----------------------------------------------------------------------------------------

sub Initialize
  response.write "<?xml version=""1.0"" encoding=""UTF-8"" ?>"
  response.write "<callxml>"
end sub  ' Initialize sub

'-----------------------------------------------------------------------------------------

sub Closure
  response.write "</callxml>"
end sub  ' Closure sub

'-----------------------------------------------------------------------------------------

sub MainMenu
  ' ---------------------------------------------------------------------- 
  ' Welcome to telephone simon.  This is the first file that should be run 
  ' This will play a welcome greeting and explain the rules.               
  ' ---------------------------------------------------------------------- 

  response.write "<block label=""Main"">"
  
  ' ------------------------------------------------------------ 
  ' Here we set three variables.                                 
  ' CurrentNumber is the sequence of numbers Simon asks for.     
  ' TotalDigits is simply the length of that string of numbers.  
  ' Score is basically 50 points times the TotalDigits variable. 
  ' ------------------------------------------------------------ 

  response.write "<assign var=""currentnumber"" value=""""  />"
  response.write "<assign var=""totaldigits""   value=""0"" />"
  response.write "<assign var=""score""         value=""0"" />" 

  response.write "<block label=""MainMenu"" " & _
	                    "repeat=""3"" " & _
		                "cleardigits=""TRUE"">"
		  		  
  response.write "<playaudio format=""audio/wav"" " & _
		                    "value=""MainMenu.wav"" " & _		  
	                        "termdigits=""#""/>"
					  
  response.write "<wait value=""3s"" termdigits=""#""/>"
		  
	  ' --------------------------------------------------- 
	  ' By hitting the # key, the caller is ready to start. 
	  ' --------------------------------------------------- 

	  response.write "<ontermdigit value=""#"">" 
	  response.write "  <goto value=""simon.asp?menu=playing"" submit=""*"" method=""get"" />" 
	  response.write "</ontermdigit>"
	  
	  ' -------------------------------------
	  ' If the user takes too much time, then 
	  ' inform them as such and hangup.       
	  ' -------------------------------------

	  response.write "<onmaxtime>"
	  response.write "  <goto value=""YouHaveTakenTooLong.wav"" submit=""*"" method=""get"" />" 
	  response.write "</onmaxtime>" 
	  
	  response.write "<onmaxsilence>"
	  response.write "  <goto value=""YouHaveTakenTooLong.wav"" submit=""*"" method=""get"" />" 
	  response.write "</onmaxsilence>"
    response.write "</block>"

  response.write "</block>"
end sub  ' MainMenu sub

'-----------------------------------------------------------------------------------------

sub Checking
  response.write "<block> "
  
  ' --------------------------------------------------- 
  ' If the caller's guess matches the current sequence  
  ' of numbers, then play a little "ding" noise and     
  ' increase the length of the sequence.  Otherwise,    
  ' the user has lost and we go to our endgame routine. 
  ' --------------------------------------------------- 
  
  if (request("currentnumber") = request("callersguess")) then 
    response.write "<playaudio value=""Ding.wav"" />"
	
    NewScore = request("score") + 50
  
    response.write "<assign var=""score"" value=""" & NewScore & """ />"

    response.write "<goto value=""simon.asp?menu=playing"" method=""get"" submit=""*"" />"	  
  else 
    response.write "<goto value=""simon.asp?menu=endgame"" submit=""*"" method=""get"" />"
  end if  ' else statement

  response.write "</block>"
end sub  ' Checking sub

'-----------------------------------------------------------------------------------------

sub Playing

  HighestNumber = 9  'highest number to generate
  LowestNumber  = 1  'Lowest number to generate
  
  Randomize
  
  GeneratedNumber = Int((HighestNumber * Rnd) + LowestNumber)
  
  ' ------------------------------------------------ 												  
  ' We simply append a new random digit onto the end	  
  ' for each pass through this file.								  
  ' ------------------------------------------------

  NewCurrentNumber = request("currentnumber") & GeneratedNumber
  
  response.write "<assign var=""currentnumber"" value=""" & NewCurrentNumber & """ />"    
  
  ' --------------------------------------------------- 
  ' Increase the total number of digits in the sequence 
  ' --------------------------------------------------- 

  NewTotalDigits = request("totaldigits") + 1
  
  response.write "<assign var=""totaldigits"" value=""" & NewTotalDigits & """/>"

  ' ------------------------------------------------------- 
  ' Play the current number sequence for the caller to hear 
  ' ------------------------------------------------------- 
    
  response.write "<playnumber value=""" & NewCurrentNumber & """ format=""digits"" />"
			  
  ' -------------------------------------------------------- 
  ' Get the caller's guess at the digit sequence.  When they 
  ' have reached the proper length, go to the "verify" code  
  ' to check their answer.  If they take too much time, then 
  ' they have forfeited the game.                            
  ' -------------------------------------------------------- 

  response.write "<block>"
    response.write "<getdigits var=""callersguess"" " & _
			   "maxdigits=""" & NewTotalDigits & """ " & _
	  		   "cleardigits=""TRUE"" " & _
			   "maxsilence=""5s"" " & _
			   "maxtime=""30s""/>"

	  response.write "<onmaxdigits>" 
	  response.write "  <goto value=""simon.asp?menu=checking"" submit=""*"" method=""get""/>"
	  response.write "</onmaxdigits>" 

	  response.write "<onmaxtime>" 
	  response.write "  <goto value=""simon.asp?menu=endgame"" submit=""*"" method=""get"" />"
	  response.write "</onmaxtime>"
 
	  response.write "<onmaxsilence>"
	  response.write "  <goto value=""simon.asp?menu=endgame"" submit=""*"" method=""get"" />"
	  response.write "</onmaxsilence>" 
  response.write "</block>"
end sub  ' Playing sub

'-----------------------------------------------------------------------------------------

sub EndGameMenu
  response.write "<block> "
  
  ' -------------------------------------------------- 
  ' Since the caller entered an incorrect answer, play 
  ' a little "oh no!" sound, then tell them how many   
  ' points they scored.                                
  ' -------------------------------------------------- 
  
    response.write "<playaudio value=""OhNo.wav"" />"
    response.write "<playaudio value=""YouAcquired.wav"" />"  
    response.write "<playnumber value=""" & request("score") & """ format=""number"" />" 
    response.write "<playaudio value=""Points.wav"" />"  
  
    ' --------------------------------------- 
    ' Final menu.  Give them a chance to play 
    ' again by pressing the pound key.        
    ' --------------------------------------- 
  
  response.write "<block repeat=""3"" " & _
		                "cleardigits=""TRUE"">"
		  		  
  response.write "<playaudio format=""audio/wav"" " & _
		                    "value=""ThankYou.wav"" " & _		  
	                        "termdigits=""#""/>"
					  
  response.write "<wait value=""3s"" termdigits=""#""/>"

	response.write "<ontermdigit value=""#"">"
	response.write "  <goto value=""simon.asp"" method=""get"" submit=""*"" />"
	response.write "</ontermdigit>"
  response.write "</block>"
  response.write "</block>"
end sub  ' EndGameMenu sub

'-----------------------------------------------------------------------------------------

Call Initialize

if     (request("menu") = "endgame" ) then 
  Call EndGameMenu
elseif (request("menu") = "playing" ) then 
  Call Playing     
elseif (request("menu") = "checking") then 
  Call Checking    
else                                       
  Call MainMenu   
end if

Call Closure

%>